/**
 */
package de.mdelab.mlcallactions;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityParameter;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Activity Call Action</b></em>'. <!-- end-user-doc -->
 * 
 * <!-- begin-model-doc --> Invokes another activity. The returnValue of this
 * ActivityCallAction is determined by the value of returnValueParameter. In
 * addtion, the flag importOutputParameters allows to import all output
 * parameters of the activity, i.e., for each output parameter a variable will
 * be created in the scope of the current activity. Existing variables will be
 * overwritten. <!-- end-model-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link de.mdelab.mlcallactions.ActivityCallAction#getActivity <em>
 * Activity</em>}</li>
 * <li>
 * {@link de.mdelab.mlcallactions.ActivityCallAction#getReturnValueParameter
 * <em>Return Value Parameter</em>}</li>
 * <li>
 * {@link de.mdelab.mlcallactions.ActivityCallAction#isImportOutputParameters
 * <em>Import Output Parameters</em>}</li>
 * </ul>
 * </p>
 * 
 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getActivityCallAction()
 * @model
 * @generated
 */
public interface ActivityCallAction extends ParameterizedCallAction
{
	/**
	 * Returns the value of the '<em><b>Activity</b></em>' reference. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Activity</em>' reference.
	 * @see #setActivity(Activity)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getActivityCallAction_Activity()
	 * @model required="true"
	 * @generated
	 */
	Activity getActivity();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.ActivityCallAction#getActivity
	 * <em>Activity</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Activity</em>' reference.
	 * @see #getActivity()
	 * @generated
	 */
	void setActivity(Activity value);

	/**
	 * Returns the value of the '<em><b>Return Value Parameter</b></em>'
	 * reference. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Return Value Parameter</em>' reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Return Value Parameter</em>' reference.
	 * @see #setReturnValueParameter(ActivityParameter)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getActivityCallAction_ReturnValueParameter()
	 * @model
	 * @generated
	 */
	ActivityParameter getReturnValueParameter();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.ActivityCallAction#getReturnValueParameter
	 * <em>Return Value Parameter</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Return Value Parameter</em>'
	 *            reference.
	 * @see #getReturnValueParameter()
	 * @generated
	 */
	void setReturnValueParameter(ActivityParameter value);

	/**
	 * Returns the value of the '<em><b>Import Output Parameters</b></em>'
	 * attribute. The default value is <code>"false"</code>. <!-- begin-user-doc
	 * -->
	 * <p>
	 * If the meaning of the '<em>Import Output Parameters</em>' attribute isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Import Output Parameters</em>' attribute.
	 * @see #setImportOutputParameters(boolean)
	 * @see de.mdelab.mlcallactions.MlcallactionsPackage#getActivityCallAction_ImportOutputParameters()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isImportOutputParameters();

	/**
	 * Sets the value of the '
	 * {@link de.mdelab.mlcallactions.ActivityCallAction#isImportOutputParameters
	 * <em>Import Output Parameters</em>}' attribute. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Import Output Parameters</em>'
	 *            attribute.
	 * @see #isImportOutputParameters()
	 * @generated
	 */
	void setImportOutputParameters(boolean value);

} // ActivityCallAction
