/**
 */
package de.mdelab.mlcallactions.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.EMFEditPlugin;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemColorProvider;
import org.eclipse.emf.edit.provider.ITableItemFontProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.mdelab.mlcallactions.CallActionExpression;
import de.mdelab.mlcallactions.MlcallactionsFactory;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlexpressions.provider.MLExpressionItemProvider;

/**
 * This is the item provider adapter for a
 * {@link de.mdelab.mlcallactions.CallActionExpression} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class CallActionExpressionItemProvider extends MLExpressionItemProvider implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource, ITableItemLabelProvider,
		ITableItemColorProvider, ITableItemFontProvider, IItemColorProvider, IItemFontProvider
{
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CallActionExpressionItemProvider(final AdapterFactory adapterFactory)
	{
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(final Object object)
	{
		if (this.itemPropertyDescriptors == null)
		{
			super.getPropertyDescriptors(object);

		}
		return this.itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to
	 * deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand},
	 * {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in
	 * {@link #createCommand}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(final Object object)
	{
		if (this.childrenFeatures == null)
		{
			super.getChildrenFeatures(object);
			this.childrenFeatures.add(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS);
		}
		return this.childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(final Object object, final Object child)
	{
		// Check the type of the specified child object and return the proper
		// feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns CallActionExpression.gif. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object getImage(final Object object)
	{
		return this.overlayImage(object, this.getResourceLocator().getImage("full/obj16/CallActionExpression"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(final Object object)
	{
		String label = "";

		final ComposedAdapterFactory factory = new ComposedAdapterFactory(EMFEditPlugin.getComposedAdapterFactoryDescriptorRegistry());

		final CallActionExpression expression = (CallActionExpression) object;

		if (expression.getCallActions().isEmpty())
		{
			label += "[null]";
		}
		else
		{
			label += ((IItemLabelProvider) factory.adapt(expression.getCallActions().get(0), IItemLabelProvider.class)).getText(expression
					.getCallActions().get(0));

			if (expression.getCallActions().size() > 1)
			{
				label += "...";
			}
		}

		return label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to
	 * update any cached children and by creating a viewer notification, which
	 * it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void notifyChanged(final Notification notification)
	{
		this.updateChildren(notification);

		switch (notification.getFeatureID(CallActionExpression.class))
		{
			case MlcallactionsPackage.CALL_ACTION_EXPRESSION__CALL_ACTIONS:
				this.fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(final Collection<Object> newChildDescriptors, final Object object)
	{
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createLiteralDeclarationAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createVariableDeclarationAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createVariableReferenceAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createNullValueAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createUnaryOperationAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createBinaryOperationAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createCloneAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createMethodCallAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createEOperationCallAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createNewObjectAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createActivityCallAction()));

		newChildDescriptors.add(this.createChildParameter(MlcallactionsPackage.Literals.CALL_ACTION_EXPRESSION__CALL_ACTIONS,
				MlcallactionsFactory.eINSTANCE.createEObjectReferenceAction()));
	}

	@Override
	public Object getFont(final Object object)
	{
		return IItemFontProvider.ITALIC_FONT;
	}
}
