/**
 */
package de.mdelab.mlcallactions.provider;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ChildCreationExtenderManager;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IChildCreationExtender;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemColorProvider;
import org.eclipse.emf.edit.provider.IItemFontProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemColorProvider;
import org.eclipse.emf.edit.provider.ITableItemFontProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import de.mdelab.mlcallactions.MlcallactionsFactory;
import de.mdelab.mlcallactions.MlcallactionsPackage;
import de.mdelab.mlcallactions.util.MlcallactionsAdapterFactory;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.mlsdm.util.MlsdmSwitch;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.util.MlstorypatternsSwitch;

/**
 * This is the factory that is used to provide the interfaces needed to support
 * Viewers. The adapters generated by this factory convert EMF adapter
 * notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The
 * adapters also support Eclipse property sheets. Note that most of the adapters
 * are shared among multiple instances. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class MlcallactionsItemProviderAdapterFactory extends MlcallactionsAdapterFactory implements ComposeableAdapterFactory,
		IChangeNotifier, IDisposable, IChildCreationExtender
{
	/**
	 * This keeps track of the root adapter factory that delegates to this
	 * adapter factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ComposedAdapterFactory		parentAdapterFactory;

	/**
	 * This is used to implement
	 * {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected IChangeNotifier				changeNotifier					= new ChangeNotifier();

	/**
	 * This helps manage the child creation extenders. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ChildCreationExtenderManager	childCreationExtenderManager	= new ChildCreationExtenderManager(
																					MlcallactionsEditPlugin.INSTANCE,
																					MlcallactionsPackage.eNS_URI);

	/**
	 * This keeps track of all the supported types checked by
	 * {@link #isFactoryForType isFactoryForType}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected Collection<Object>			supportedTypes					= new ArrayList<Object>();

	/**
	 * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public MlcallactionsItemProviderAdapterFactory()
	{
		this.supportedTypes.add(IEditingDomainItemProvider.class);
		this.supportedTypes.add(IStructuredItemContentProvider.class);
		this.supportedTypes.add(ITreeItemContentProvider.class);
		this.supportedTypes.add(IItemLabelProvider.class);
		this.supportedTypes.add(IItemPropertySource.class);
		this.supportedTypes.add(ITableItemLabelProvider.class);
		this.supportedTypes.add(ITableItemColorProvider.class);
		this.supportedTypes.add(ITableItemFontProvider.class);
		this.supportedTypes.add(IItemColorProvider.class);
		this.supportedTypes.add(IItemFontProvider.class);
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.CallActionExpression} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CallActionExpressionItemProvider	callActionExpressionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.CallActionExpression}. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createCallActionExpressionAdapter()
	{
		if (this.callActionExpressionItemProvider == null)
		{
			this.callActionExpressionItemProvider = new CallActionExpressionItemProvider(this);
		}

		return this.callActionExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.LiteralDeclarationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected LiteralDeclarationActionItemProvider	literalDeclarationActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.LiteralDeclarationAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createLiteralDeclarationActionAdapter()
	{
		if (this.literalDeclarationActionItemProvider == null)
		{
			this.literalDeclarationActionItemProvider = new LiteralDeclarationActionItemProvider(this);
		}

		return this.literalDeclarationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.VariableDeclarationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected VariableDeclarationActionItemProvider	variableDeclarationActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.VariableDeclarationAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createVariableDeclarationActionAdapter()
	{
		if (this.variableDeclarationActionItemProvider == null)
		{
			this.variableDeclarationActionItemProvider = new VariableDeclarationActionItemProvider(this);
		}

		return this.variableDeclarationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.VariableReferenceAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected VariableReferenceActionItemProvider	variableReferenceActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.VariableReferenceAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createVariableReferenceActionAdapter()
	{
		if (this.variableReferenceActionItemProvider == null)
		{
			this.variableReferenceActionItemProvider = new VariableReferenceActionItemProvider(this);
		}

		return this.variableReferenceActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.NullValueAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected NullValueActionItemProvider	nullValueActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.NullValueAction}. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createNullValueActionAdapter()
	{
		if (this.nullValueActionItemProvider == null)
		{
			this.nullValueActionItemProvider = new NullValueActionItemProvider(this);
		}

		return this.nullValueActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.UnaryOperationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected UnaryOperationActionItemProvider	unaryOperationActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.UnaryOperationAction}. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createUnaryOperationActionAdapter()
	{
		if (this.unaryOperationActionItemProvider == null)
		{
			this.unaryOperationActionItemProvider = new UnaryOperationActionItemProvider(this);
		}

		return this.unaryOperationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.BinaryOperationAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected BinaryOperationActionItemProvider	binaryOperationActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.BinaryOperationAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createBinaryOperationActionAdapter()
	{
		if (this.binaryOperationActionItemProvider == null)
		{
			this.binaryOperationActionItemProvider = new BinaryOperationActionItemProvider(this);
		}

		return this.binaryOperationActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.CloneAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CloneActionItemProvider	cloneActionItemProvider;

	/**
	 * This creates an adapter for a {@link de.mdelab.mlcallactions.CloneAction}
	 * . <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createCloneActionAdapter()
	{
		if (this.cloneActionItemProvider == null)
		{
			this.cloneActionItemProvider = new CloneActionItemProvider(this);
		}

		return this.cloneActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.CallActionParameter} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CallActionParameterItemProvider	callActionParameterItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.CallActionParameter}. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createCallActionParameterAdapter()
	{
		if (this.callActionParameterItemProvider == null)
		{
			this.callActionParameterItemProvider = new CallActionParameterItemProvider(this);
		}

		return this.callActionParameterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.MethodCallAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MethodCallActionItemProvider	methodCallActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.MethodCallAction}. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createMethodCallActionAdapter()
	{
		if (this.methodCallActionItemProvider == null)
		{
			this.methodCallActionItemProvider = new MethodCallActionItemProvider(this);
		}

		return this.methodCallActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.EOperationCallAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EOperationCallActionItemProvider	eOperationCallActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.EOperationCallAction}. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createEOperationCallActionAdapter()
	{
		if (this.eOperationCallActionItemProvider == null)
		{
			this.eOperationCallActionItemProvider = new EOperationCallActionItemProvider(this);
		}

		return this.eOperationCallActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.NewObjectAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected NewObjectActionItemProvider	newObjectActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.NewObjectAction}. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createNewObjectActionAdapter()
	{
		if (this.newObjectActionItemProvider == null)
		{
			this.newObjectActionItemProvider = new NewObjectActionItemProvider(this);
		}

		return this.newObjectActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.ActivityCallAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActivityCallActionItemProvider	activityCallActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.ActivityCallAction}. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createActivityCallActionAdapter()
	{
		if (this.activityCallActionItemProvider == null)
		{
			this.activityCallActionItemProvider = new ActivityCallActionItemProvider(this);
		}

		return this.activityCallActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link de.mdelab.mlcallactions.EObjectReferenceAction} instances. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EObjectReferenceActionItemProvider	eObjectReferenceActionItemProvider;

	/**
	 * This creates an adapter for a
	 * {@link de.mdelab.mlcallactions.EObjectReferenceAction}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter createEObjectReferenceActionAdapter()
	{
		if (this.eObjectReferenceActionItemProvider == null)
		{
			this.eObjectReferenceActionItemProvider = new EObjectReferenceActionItemProvider(this);
		}

		return this.eObjectReferenceActionItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory()
	{
		return this.parentAdapterFactory == null ? this : this.parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(final ComposedAdapterFactory parentAdapterFactory)
	{
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(final Object type)
	{
		return this.supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the
	 * adapter. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Adapter adapt(final Notifier notifier, final Object type)
	{
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Object adapt(final Object object, final Object type)
	{
		if (this.isFactoryForType(type))
		{
			final Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || ((Class<?>) type).isInstance(adapter))
			{
				return adapter;
			}
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public List<IChildCreationExtender> getChildCreationExtenders()
	{
		return this.childCreationExtenderManager.getChildCreationExtenders();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public Collection<?> getNewChildDescriptors(final Object object, final EditingDomain editingDomain)
	{
		return this.childCreationExtenderManager.getNewChildDescriptors(object, editingDomain);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator()
	{
		return this.childCreationExtenderManager;
	}

	/**
	 * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void addListener(final INotifyChangedListener notifyChangedListener)
	{
		this.changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void removeListener(final INotifyChangedListener notifyChangedListener)
	{
		this.changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to
	 * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(final Notification notification)
	{
		this.changeNotifier.fireNotifyChanged(notification);

		if (this.parentAdapterFactory != null)
		{
			this.parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public void dispose()
	{
		if (this.callActionExpressionItemProvider != null)
		{
			this.callActionExpressionItemProvider.dispose();
		}
		if (this.literalDeclarationActionItemProvider != null)
		{
			this.literalDeclarationActionItemProvider.dispose();
		}
		if (this.variableDeclarationActionItemProvider != null)
		{
			this.variableDeclarationActionItemProvider.dispose();
		}
		if (this.variableReferenceActionItemProvider != null)
		{
			this.variableReferenceActionItemProvider.dispose();
		}
		if (this.nullValueActionItemProvider != null)
		{
			this.nullValueActionItemProvider.dispose();
		}
		if (this.unaryOperationActionItemProvider != null)
		{
			this.unaryOperationActionItemProvider.dispose();
		}
		if (this.binaryOperationActionItemProvider != null)
		{
			this.binaryOperationActionItemProvider.dispose();
		}
		if (this.cloneActionItemProvider != null)
		{
			this.cloneActionItemProvider.dispose();
		}
		if (this.callActionParameterItemProvider != null)
		{
			this.callActionParameterItemProvider.dispose();
		}
		if (this.methodCallActionItemProvider != null)
		{
			this.methodCallActionItemProvider.dispose();
		}
		if (this.eOperationCallActionItemProvider != null)
		{
			this.eOperationCallActionItemProvider.dispose();
		}
		if (this.newObjectActionItemProvider != null)
		{
			this.newObjectActionItemProvider.dispose();
		}
		if (this.activityCallActionItemProvider != null)
		{
			this.activityCallActionItemProvider.dispose();
		}
		if (this.eObjectReferenceActionItemProvider != null)
		{
			this.eObjectReferenceActionItemProvider.dispose();
		}
	}

	/**
	 * A child creation extender for the {@link MlsdmPackage}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static class MlsdmChildCreationExtender implements IChildCreationExtender
	{
		/**
		 * The switch for creating child descriptors specific to each extended
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		protected static class CreationSwitch extends MlsdmSwitch<Object>
		{
			/**
			 * The child descriptors being populated. <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			protected List<Object>	newChildDescriptors;

			/**
			 * The domain in which to create the children. <!-- begin-user-doc
			 * --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			protected EditingDomain	editingDomain;

			/**
			 * Creates the a switch for populating child descriptors in the
			 * given domain. <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			CreationSwitch(final List<Object> newChildDescriptors, final EditingDomain editingDomain)
			{
				this.newChildDescriptors = newChildDescriptors;
				this.editingDomain = editingDomain;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			@Override
			public Object caseActivityEdge(final ActivityEdge object)
			{
				this.newChildDescriptors.add(this.createChildParameter(MlsdmPackage.Literals.ACTIVITY_EDGE__GUARD_EXPRESSION,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				this.newChildDescriptors.add(this.createChildParameter(MlsdmPackage.Literals.ACTIVITY_EDGE__ASSERTION_EXPRESSIONS,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				return null;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			@Override
			public Object caseExpressionActivityNode(final ExpressionActivityNode object)
			{
				this.newChildDescriptors.add(this.createChildParameter(MlsdmPackage.Literals.EXPRESSION_ACTIVITY_NODE__EXPRESSIONS,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				return null;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			@Override
			public Object caseOutputParameterValue(final OutputParameterValue object)
			{
				this.newChildDescriptors.add(this.createChildParameter(MlsdmPackage.Literals.OUTPUT_PARAMETER_VALUE__EXPRESSION,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				return null;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			protected CommandParameter createChildParameter(final Object feature, final Object child)
			{
				return new CommandParameter(null, feature, child);
			}

		}

		/**
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		@Override
		public Collection<Object> getNewChildDescriptors(final Object object, final EditingDomain editingDomain)
		{
			final ArrayList<Object> result = new ArrayList<Object>();
			new CreationSwitch(result, editingDomain).doSwitch((EObject) object);
			return result;
		}

		/**
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		@Override
		public ResourceLocator getResourceLocator()
		{
			return MlcallactionsEditPlugin.INSTANCE;
		}
	}

	/**
	 * A child creation extender for the {@link MlstorypatternsPackage}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static class MlstorypatternsChildCreationExtender implements IChildCreationExtender
	{
		/**
		 * The switch for creating child descriptors specific to each extended
		 * class. <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		protected static class CreationSwitch extends MlstorypatternsSwitch<Object>
		{
			/**
			 * The child descriptors being populated. <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			protected List<Object>	newChildDescriptors;

			/**
			 * The domain in which to create the children. <!-- begin-user-doc
			 * --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			protected EditingDomain	editingDomain;

			/**
			 * Creates the a switch for populating child descriptors in the
			 * given domain. <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			CreationSwitch(final List<Object> newChildDescriptors, final EditingDomain editingDomain)
			{
				this.newChildDescriptors = newChildDescriptors;
				this.editingDomain = editingDomain;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			@Override
			public Object caseStoryPattern(final StoryPattern object)
			{
				this.newChildDescriptors.add(this.createChildParameter(MlstorypatternsPackage.Literals.STORY_PATTERN__CONSTRAINTS,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				return null;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			@Override
			public Object caseStoryPatternObject(final StoryPatternObject object)
			{
				this.newChildDescriptors.add(this.createChildParameter(MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__CONSTRAINTS,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				this.newChildDescriptors.add(this.createChildParameter(
						MlstorypatternsPackage.Literals.STORY_PATTERN_OBJECT__ASSIGNMENT_EXPRESSION,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				return null;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			@Override
			public Object caseAttributeAssignment(final AttributeAssignment object)
			{
				this.newChildDescriptors.add(this.createChildParameter(
						MlstorypatternsPackage.Literals.ATTRIBUTE_ASSIGNMENT__ASSIGNMENT_EXPRESSION,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				return null;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			@Override
			public Object caseExpressionLink(final ExpressionLink object)
			{
				this.newChildDescriptors.add(this.createChildParameter(MlstorypatternsPackage.Literals.EXPRESSION_LINK__EXPRESSION,
						MlcallactionsFactory.eINSTANCE.createCallActionExpression()));

				return null;
			}

			/**
			 * <!-- begin-user-doc --> <!-- end-user-doc -->
			 * 
			 * @generated
			 */
			protected CommandParameter createChildParameter(final Object feature, final Object child)
			{
				return new CommandParameter(null, feature, child);
			}

		}

		/**
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		@Override
		public Collection<Object> getNewChildDescriptors(final Object object, final EditingDomain editingDomain)
		{
			final ArrayList<Object> result = new ArrayList<Object>();
			new CreationSwitch(result, editingDomain).doSwitch((EObject) object);
			return result;
		}

		/**
		 * <!-- begin-user-doc --> <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		@Override
		public ResourceLocator getResourceLocator()
		{
			return MlcallactionsEditPlugin.INSTANCE;
		}
	}

}
